libcoap 4.3.2rc2

Data Structures | Macros | Typedefs | Functions
coap_crypto_internal.h File Reference

COAP crypto internal information. More...

`#include "oscore/oscore_cose.h"`

Go to the source code of this file.

## Data Structures
struct | coap_crypto_aes_ccm_t
| The structure that holds the AES Crypto information. More...
struct | coap_crypto_param_t
| The common structure that holds the Crypto information. More...

## Macros
#define | COAP_CRYPTO_MAX_KEY_SIZE (32)
#define | COAP_OSCORE_DEFAULT_REPLAY_WINDOW 32

## Typedefs
typedef coap_bin_const_t | coap_crypto_key_t
| The structure that holds the Crypto Key. More...
typedef struct coap_crypto_aes_ccm_t | coap_crypto_aes_ccm_t
| The structure that holds the AES Crypto information. More...
typedef struct coap_crypto_param_t | coap_crypto_param_t
| The common structure that holds the Crypto information. More...

## Functions
int | coap_crypto_check_cipher_alg (cose_alg_t alg)
| Check whether the defined cipher algorithm is supported by the underlying crypto library. More...
int | coap_crypto_check_hkdf_alg (cose_hkdf_alg_t hkdf_alg)
| Check whether the defined hkdf algorithm is supported by the underlying crypto library. More...
int | coap_crypto_aead_encrypt (const coap_crypto_param_t *params, coap_bin_const_t *data, coap_bin_const_t *aad, uint8_t *result, size_t *max_result_len)
| Encrypt the provided plaintext data. More...
int | coap_crypto_aead_decrypt (const coap_crypto_param_t *params, coap_bin_const_t *data, coap_bin_const_t *aad, uint8_t *result, size_t *max_result_len)
| Decrypt the provided encrypted data into plaintext. More...
int | coap_crypto_hmac (cose_hmac_alg_t hmac_alg, coap_bin_const_t *key, coap_bin_const_t *data, coap_bin_const_t **hmac)
| Create a HMAC hash of the provided data. More...
int | coap_crypto_hash (cose_alg_t alg, const coap_bin_const_t *data, coap_bin_const_t **hash)
| Create a hash of the provided data. More...

## Detailed Description

COAP crypto internal information.

Definition in file coap_crypto_internal.h.